; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

lives = lives - 1
collected = 0
jump = 0
If lives > 0 And level < 21

; DIE SCREEN
	If soundEnabled Then PlaySound sndDeath

	CameraClsColor camDefault, 255, 0, 0
	
	Gosub RenderScreen
	DrawImage imgWindow, 125, 100
	
	ShowPointer
	
	Color 0, 0, 0
	Text 146, 106, "You died!"
	Color 0, 105, 0
	Text 145, 105, "You died!"
	
	Color 0, 0, 0
	Text 286, 171, "To avoid seeing this message again,", True
	Text 286, 191, "avoid collision with walls and yourself.", True
	Color 0, 255, 0
	Text 285, 170, "To avoid seeing this message again,", True
	Text 285, 190, "avoid collision with walls and yourself.", True
	
	Gosub CloseWindow
	
	HidePointer

	Gosub Kill

ElseIf lives <= 0

; GAME OVER
	
	If Not abandon Then
		FreeSound sndMusic
		chosen = False
		If score > 100000 Then
			newlives = 2
			newscore = score - 100000
		Else
			newlives = 1
			newscore = 0
		End If
		PlaySound sndDeath
		mouse = 0
		While Not chosen
			DrawImage imgContinue, 0, 0
			Text 320, 240, "You have now " + score + " points. If you choose YES, you will continue", True, True
			Text 320, 260, "on the same level with " + newlives + " lives and " + newscore + " points.", True, True
			DrawImage imgMarquee, MouseX(), MouseY()
			Mouse = GetMouse()
			If Mouse = 1 And (MouseArea(50, 380, 150, 50) Or MouseArea(440, 380, 150, 50)) Then
				chosen = True
			End If
			FlushMouse
			Flip
		Wend
		PlaySound sndClick
		If MouseX() < 320 Then
			score = newscore
			lives = newlives
			Gosub Level
		End If
					
	End If
	
;;;;;;; END MOVIE
	
; START OUTRO LOSE
skip = False
FlushKeys
Cls

; FREE ENTITIES

If box Then
	FreeEntity lgtBox
	FreeEntity objBox
	box = False
End If

If present Then
	FreeEntity lgtNuke
	FreeEntity objNuke
	present = False
End If

; FREE NIBBLE
FreeEntity camDefault
FreeEntity lgtHead
For count = 0 To length
	FreeEntity objNibbler(count)
Next		

FreeEntity objFloor
FreeEntity NorthWall
FreeEntity SouthWall
FreeEntity EastWall
FreeEntity WestWall
FreeEntity Sky
FreeTexture texFloor
FreeTexture texWall
FreeTexture texBigWall
If mirror Then
	FreeEntity mirFloor
End If

; FREE WALLS, IF ANY
For x = 1 To 25
	For y = 1 To 25
		If walls(x, y) Then
			FreeEntity objWalls(x, y)
			walls(x,y) = 0
		End If
	Next		
Next
newg = False

; LOAD OUTRO
texEarth = LoadTexture("images\earth2.jpg")
objEarth = CreateSphere(32)
texNibble = LoadTexture("images\nibble.bmp")
Dim objRads(3)
SeedRnd(MilliSecs())
For count = 0 To 2
	objRads(count) = CreateSphere(5, objEarth)
	EntityTexture objRads(count), texNibble
	RotateEntity objRads(count), Rnd(0, 360), Rnd(0, 360), Rnd(0, 360)
	ScaleEntity objRads(count), 1.4 + Rnd(0, 0.1), 1.4 + Rnd(0, 0.1), 1.4 + Rnd(0, 0.1)
	EntityAlpha objRads(count), 0.1
Next
EntityTexture objEarth, texEarth
texMoon = LoadTexture("images\moon.jpg")
objMoon = CreateSphere(32)
EntityTexture objMoon, texMoon
sprStars = LoadSprite("images\starfield.jpg")
SpriteViewMode sprStars, 1
camIntro = CreateCamera()
ScaleEntity objEarth, 1.3, 1.3, 1.3
ScaleEntity objMoon, 0.35, 0.35, 0.35
MoveEntity objMoon, -4, 0.6, 0
MoveEntity camIntro, 0.6, 0.8, -5
ScaleSprite sprStars, 12, 12
MoveEntity sprStars, -3, 0, 3
PointEntity camIntro, objEarth
TurnEntity objEarth, 0, -105, 0
fntIntro = LoadFont("Garamond", 22, True)
SetFont fntIntro
tmr = MilliSecs()
oldMessage$ = ""
newMessage$ = ""
omA# = 0
nmA# = 0
nextMsg = 2000
finished = True
light# = 0
lgtSun = CreateLight(2)
LightRange lgtSun, 3
LightColor lgtSun, 205, 175, 0
PositionEntity lgtSun, -3, 0, -2
Dim objExplodes(10)
Dim scales#(10)
Dim scalesChange#(10)
Dim finishedExpl(10)
texExplode = LoadTexture("images\explode.jpg")
For count = 0 To 9
	objExplodes(count) = CreateSphere(8, objEarth)
	EntityTexture objExplodes(count), texExplode
	scalesChange(count) = 0.03
	scales(count) = 0
	ScaleEntity objExplodes(count), 0, 0, 0
	finishedExpl(count) = True
	EntityAlpha objExplodes(count), 0.7
Next
sprBlack = CreateSprite()
SpriteViewMode sprBlack, 1
MoveEntity sprBlack, 0, 0, -4.1
ScaleSprite sprBlack, 3, 3
EntityColor sprBlack, 0, 0, 0
EntityAlpha sprBlack, light
AmbientLight 205, 205, 205
ScaleTexture texNibble, 0.2, 0.2
CameraZoom camIntro, 1.8
tmrExplosions = MilliSecs()
phase = 0

If musicEnabled Then
	sndMusic = LoadSound("sounds\intro.mp3")
	LoopSound sndMusic
	chnMusic = PlaySound(sndMusic)
	ChannelVolume chnMusic, musicVol
End If

If soundEnabled Then
	sndExplode = LoadSound("sounds\explode.mp3")
	SoundVolume sndExplode, soundVol
End If

SeedRnd MilliSecs()
nextExpl = Rand(900, 1600)
sizes# = 0.4

While phase < 8 And (Not skip)

	WaitTimer(frmRateTimer)

	key = GetKey()
	If key <> 0 Then
		skip = True
	End If

; CREATE NEW EXPLOSION
	If tmrExplosions < (MilliSecs() - nextExpl)
		tmrExplosions = MilliSecs()
		nextExpl = Rand(800, 1700) - phase * 100
		ex = -1
		For count = 0 To 9
			If finishedExpl(count) Then
				ex = count
				finishedExpl(count) = False
				count = 10
				If soundEnabled Then PlaySound sndExplode
					
			End If
		Next
		If ex > -1 Then
			RotateEntity objExplodes(ex), Rand(1, 360), Rand(1, 360), Rand(1, 360)
			MoveEntity objExplodes(ex), 0.9, 0, 0
		End If
	End If

; UPDATE EXPLOSIONS
	For count = 0 To 9
		If Not finishedExpl(count) Then
			If scalesChange(count) > 0 Then
				scales(count) = scales(count) + scalesChange(count)
				ScaleEntity objExplodes(count), scales(count), scales(count), scales(count)
				If scales(count) > sizes Then
					scalesChange(count) = -0.03
				End If
			ElseIf scalesChange(count) < 0 Then
				scales(count) = scales(count) + scalesChange(count)
				ScaleEntity objExplodes(count), scales(count), scales(count), scales(count)
				If scales(count) < 0.1 Then
					scalesChange(count) = 0
				End If
			Else
				scalesChange(count) = 0.03
				finishedExpl(count) = True
				PositionEntity objExplodes(count), 0, 0, 0
				sizes = sizes + 0.001
			End If
		End If
	Next

; UPDATE EARTH AND MOON

	TurnEntity objEarth, 0, 0.1, 0
	PointEntity objMoon, objEarth
	MoveEntity objMoon, -0.01, 0, 0

; PUT NEW MESSAGES

	If (tmr < MilliSecs() - nextMsg) And finished
		finished = False
		phase = phase + 1
		msgid = msgid + 1
		Select phase
			Case 1
				newMessage = "This last hope failed to save the Earth"
			Case 2
				newMessage = "It is now doomed to die under radiations."
			Case 3
				newMessage = "However, a new element came into play:"
			Case 4
				newMessage = "War started..."
			Case 5
				newMessage = "again..."
			Case 6
				newMessage = "..."
			Default
				newMessage = "                                     "
		End Select
		nextMsg = (Len(newMessage) + 2) * 100
	End If

; BLACKEN OUT	
	If phase > 6 Then
		light = light + 0.01
		EntityAlpha sprBlack, light
		If musicEnabled Then
			ChannelVolume chnMusic, musicVol * (1 - light)
		End If
		If soundEnabled Then
			SoundVolume sndExplode, soundVol * (1 - light)
		End If
	End If

; RENDER WORLD
	UpdateWorld
	RenderWorld

; FADE MESSAGES AROUND
	If msgid <> lmsgid Then
		If omA > 0 Then
			omA = omA - 0.05
		ElseIf nmA < 1 Then
			nmA = nmA + 0.05
		Else
			oldMessage = newMessage
			newMessage = ""
			omA = 1
			nmA = 0
			lmsgid = msgid	
			finished = True
			tmr = MilliSecs()
		End If	
	End If
	
	If omA > 0 Then
		Color 105* omA, 105 * omA, 105 * omA
		Text 321, 421, oldMessage, True, True
		Color 25 * omA, 168 * omA, 230 * omA
		Text 320, 420, oldMessage, True, True
	End If
	
	If nmA > 0 Then
		Color 105 * nmA, 105 * nmA, 105 * nmA
		Text 321, 421, newMessage, True, True
		Color 25 * nmA, 168 * nmA, 230 * nmA
		Text 320, 420, newMessage, True, True
	End If
	
	Flip
Wend

; UNLOAD OUTRO LOSE
FreeTexture texEarth
For count = 0 To 9
	FreeEntity objExplodes(count)
Next
For count = 0 To 2
	FreeEntity objRads(count)
Next
FreeEntity objEarth
FreeTexture texMoon
FreeEntity objMoon
FreeEntity sprStars
FreeEntity camIntro
FreeFont fntIntro
FreeTexture texNibble
FreeEntity lgtSun
FreeTexture texExplode
If musicEnabled Then FreeSound sndMusic
If soundEnabled Then FreeSound sndExplode
FreeEntity sprBlack

Cls

;;;;;;; END MOVIE

	Gosub Ended
End If

.Finish

If lives >= 0 Then

; FINISHED THE GAME
	If soundEnabled Then PlaySound sndWin
	
	Gosub RenderScreen
	DrawImage imgWindow, 125, 100
	
	ShowPointer
	
	Color 0, 0, 0
	Text 146, 106, "Finished!"
	Color 0, 105, 0
	Text 145, 105, "Finished!"
	
	Color 0, 0, 0
	Text 286, 171, "Congratulations! You have finished the", True
	Text 286, 191, "game with a score of " + score + ".", True
	Color 0, 255, 0
	Text 285, 170, "Congratulations! You have finished the", True
	Text 285, 190, "game with a score of " + score + ".", True
	
	Gosub CloseWindow
	
	HidePointer

If soundEnabled Then 
	FreeSound sndWin
	sndWin = LoadSound("sounds\win.mp3")
End If

; START OUTRO WIN
skip = False
FlushKeys
Cls

; FREE ENTITIES

If box Then
	FreeEntity lgtBox
	FreeEntity objBox
	box = False
End If

If present Then
	FreeEntity lgtNuke
	FreeEntity objNuke
	present = False
End If

; FREE NIBBLE
FreeEntity camDefault
FreeEntity lgtHead
For count = 0 To length
	FreeEntity objNibbler(count)
Next		

FreeEntity objFloor
FreeEntity NorthWall
FreeEntity SouthWall
FreeEntity EastWall
FreeEntity WestWall
FreeEntity Sky
FreeTexture texFloor
FreeTexture texWall
FreeTexture texBigWall
If mirror Then
	FreeEntity mirFloor
End If

; FREE WALLS, IF ANY
For x = 1 To 25
	For y = 1 To 25
		If walls(x, y) Then
			FreeEntity objWalls(x, y)
			walls(x,y) = 0
		End If
	Next		
Next
newg = False

; LOAD OUTRO

Dim texFW(3)
For i = 1 To 3
	texFW(i) = LoadTexture("images\fw" + i + ".tga", 2)
Next

texEarth = LoadTexture("images\earth.jpg")
objEarth = CreateSphere(32)
texNibble = LoadTexture("images\nibble.bmp")
EntityTexture objEarth, texEarth
texMoon = LoadTexture("images\moon.jpg")
objMoon = CreateSphere(32)
EntityTexture objMoon, texMoon
sprStars = LoadSprite("images\starfield.jpg")
SpriteViewMode sprStars, 1
camIntro = CreateCamera()
ScaleEntity objEarth, 1.3, 1.3, 1.3
ScaleEntity objMoon, 0.35, 0.35, 0.35
MoveEntity objMoon, -4, 0.6, 0
MoveEntity camIntro, 0.6, 0.8, -5
ScaleSprite sprStars, 12, 12
MoveEntity sprStars, -3, 0, 3
PointEntity camIntro, objEarth
TurnEntity objEarth, 0, -85, 0
fntIntro = LoadFont("Garamond", 22, True)
SetFont fntIntro
tmr = MilliSecs()
oldMessage$ = ""
newMessage$ = ""
omA# = 0
nmA# = 0
nextMsg = 2000
finished = True
light# = 0
lgtSun = CreateLight(2)
LightRange lgtSun, 3
LightColor lgtSun, 205, 175, 0
PositionEntity lgtSun, -3, 0, -2
Dim emtExplodes(15)
sprBlack = CreateSprite()
SpriteViewMode sprBlack, 1
MoveEntity sprBlack, 0, 0, -4.1
ScaleSprite sprBlack, 3, 3
EntityColor sprBlack, 0, 0, 0
EntityAlpha sprBlack, light
AmbientLight 205, 205, 205
ScaleTexture texNibble, 0.2, 0.2
CameraZoom camIntro, 1.2
tmrExplosions = MilliSecs()
Dim objNibbles(100)
ScaleTexture texNibble, 0.2, 0.2
If soundEnabled Then sndWarp = LoadSound("sounds\warp.mp3")
coming = False
phase = 0

If musicEnabled Then
	sndMusic = LoadSound("sounds\win.mp3")
	LoopSound sndMusic
	chnMusic = PlaySound(sndMusic)
	ChannelVolume chnMusic, musicVol
End If

nextExpl = Rand(900, 1600)
sizes# = 0.45

While phase < 8 And (Not skip)

	WaitTimer(frmRateTimer)

	key = GetKey()
	If key <> 0 Then
		skip = True
	End If

; CREATE NEW EXPLOSION
	If tmrExplosions < (MilliSecs() - nextExpl)
		tmrExplosions = MilliSecs()
		nextExpl = Rand(600, 1600) - phase * 150
		emtExplodes(expI) = PW_CreateEmitter()
		PW_SetEmitter(emtExplodes(expI), 135, 15, 2, 135, 180, 360)
		PW_SetParticle(emtExplodes(expI), objTri, 0, 0, camIntro, 0)
		PW_SetTexture(emtExplodes(expI), texFW(Rand(1, 3)), 0, 0, 0)
		PW_SetVelocity(emtExplodes(expI), 0.3, 0, 0.7, 0)
		PW_SetAlpha(emtExplodes(expI), 0.8, 0, 10)
		PW_SetScale(emtExplodes(expI), 0.1, 0.1, 0.1, 0, 0.999)
		PositionEntity emtExplodes(expI), EntityX(objEarth), EntityY(objEarth), EntityZ(objEarth)
		RotateEntity emtExplodes(expI), Rnd(0, 360), Rnd(0, 360), Rnd(0, 360)
		MoveEntity emtExplodes(expI), 0, 0, 1.5
		expI = expI + 1
		If expI = 15 Then
			expI = 0
		End If
	End If

; UPDATE EARTH AND MOON

	TurnEntity objEarth, 0, 0.1, 0
	PointEntity objMoon, objEarth
	MoveEntity objMoon, -0.01, 0, 0

; PUT NEW MESSAGES

	If (tmr < MilliSecs() - nextMsg) And finished
		finished = False
		phase = phase + 1
		msgid = msgid + 1
		Select phase
			Case 1
				newMessage = "The Earth is moved by celebrations."
			Case 2
				newMessage = "It has been saved;"
			Case 3
				newMessage = "The nuclear nibble absorbed all radiations."
			Case 4
				newMessage = "What awaits humanity next?"
			Case 5
				newMessage = "No one knows..."
			Case 6
				newMessage = "..."
			Default
				newMessage = "                                     "
		End Select
		nextMsg = (Len(newMessage) + 2) * 100
	End If

; BLACKEN OUT	
	If phase > 6 Then
		light = light + 0.01
		EntityAlpha sprBlack, light
		If musicEnabled Then
			ChannelVolume chnMusic, musicVol * (1 - light)
		End If
	End If

; ACTIVATE NIBBLE
	If (Not coming) And (phase = 5) Then
		If soundEnabled Then PlaySound sndWarp
		coming = True
		SeedRnd MilliSecs()
		For count = 0 To 99
			objNibbles(count) = CreateSphere(2)
			ScaleEntity objNibbles(count), 0.03, 0.03, 0.03
			EntityTexture objNibbles(count), texNibble
			RotateEntity objNibbles(count), Rand(0, 360), Rand(0, 360), Rand(0, 360)
		Next
		PointEntity objNibbles(0), camIntro
		TurnEntity objNibbles(0), 8, 0, 0
	End If
	If coming Then
		For count = 99 To 1 Step -1
			PositionEntity objNibbles(count), EntityX(objNibbles(count - 1)), EntityY(objNibbles(count - 1)), EntityZ(objNibbles(count - 1))
		Next
		MoveEntity objNibbles(0), 0, 0, 0.05
	End If

; RENDER WORLD
	PW_UpdateEmitters()
	PW_UpdateParticles()
	UpdateWorld
	RenderWorld

; FADE MESSAGES AROUND
	If msgid <> lmsgid Then
		If omA > 0 Then
			omA = omA - 0.05
		ElseIf nmA < 1 Then
			nmA = nmA + 0.05
		Else
			oldMessage = newMessage
			newMessage = ""
			omA = 1
			nmA = 0
			lmsgid = msgid	
			finished = True
			tmr = MilliSecs()
		End If	
	End If
	
	If omA > 0 Then
		Color 105* omA, 105 * omA, 105 * omA
		Text 321, 421, oldMessage, True, True
		Color 25 * omA, 168 * omA, 230 * omA
		Text 320, 420, oldMessage, True, True
	End If
	
	If nmA > 0 Then
		Color 105 * nmA, 105 * nmA, 105 * nmA
		Text 321, 421, newMessage, True, True
		Color 25 * nmA, 168 * nmA, 230 * nmA
		Text 320, 420, newMessage, True, True
	End If
	
	Flip
Wend

; UNLOAD OUTRO LOSE
FreeTexture texEarth
FreeEntity objEarth
FreeTexture texMoon
FreeEntity objMoon
FreeEntity sprStars
FreeEntity camIntro
FreeFont fntIntro
FreeTexture texNibble
FreeEntity lgtSun
If musicEnabled Then FreeSound sndMusic
FreeEntity sprBlack
If soundEnabled Then FreeSound sndWarp
If coming Then
	For count = 0 To 99
		FreeEntity objNibbles(count)
	Next
End If

Cls

; END MOVIE

End If

.Ended

filHS = ReadFile("data\highscores.dat")
	For count = 0 To 9
		HSName(count) = ReadString(filHS)	
		HSDiff(count) = ReadInt(filHS)
		HSLevel(count) = ReadInt(filHS)
		HSScore(count) = ReadInt(filHS)
	Next 
CloseFile(filHS)

count = 9
HSPos = 11
While score > HSScore(count) And HSPos > 1
	If score > HSScore(count) Then
		HSPos = HSPos - 1
	End If
	If count > 0 Then
		count = count - 1
	End If
Wend

If HSPos = 11 Then
	message = "Sorry, you didn't make it to the top 10 nibblers!"
Else
	If HSPos = 1 Then
		Qual$ = "st"
	ElseIf HSPos = 2 Then
		Qual$ = "nd"
	ElseIf HSPos = 3 Then
		Qual$ = "rd"
	Else
		Qual$ = "th"
	End If
	message = "Yeah! You're qualified as the " + HSPos + Qual + " best nibbler!"
	For count = 9 To (HSPos - 1) Step -1
		If count < 9 Then
			HSName(count + 1) = HSName(count)
			HSDiff(count + 1) = HSDiff(count)
			HSLevel(count + 1) = HSLevel(count)
			HSScore(count + 1) = HSScore(count)			
		End If
	Next
	HSName(HSPos - 1) = Name
	HSDiff(HSPos - 1) = Difficulty
	If level = 21 Then
		level = 20
		HSName(HSPos - 1) = "*" + Name
	End If
	HSLevel(HSPos - 1) = Level
	HSScore(HSPos - 1) = Score
End If

filHS = WriteFile("data\highscores.dat")
	For count = 0 To 9
		WriteString filHS, HSName(count)
		WriteInt filHS, HSDiff(count)
		WriteInt filHS, HSLevel(count)
		WriteInt filHS, HSScore(count)
	Next 
CloseFile(filHS)

Gosub GameMenu