; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

; LOAD INTRO
texLogo = LoadTexture("images\logo.jpg")
camLogo = CreateCamera()
objLogo = CreateCube()
objNuke = LoadMesh("models\nuke.3ds")
RotateEntity objNuke, 90, 0, 0
ScaleEntity objNuke, 0.0035, 0.0035, 0.0031
PositionEntity objNuke, 1, .85, 0.1
EntityAlpha objNuke, 0
EntityTexture objLogo, texLogo
EntityColor objNuke, 255, 255, 0
FitMesh objLogo, 0, 0, 0, 2.0, 1.5, 0.1
EntityFX objLogo, 1
MoveEntity camLogo, 1, 0.75, -1
AmbientLight 255, 255, 255
If masking Then
	imgPresents = LoadImage("images\presents.bmp")
	imgNN3D = LoadImage("images\nn3d.bmp")
Else
	imgPresents = LoadImage("images\presents-nm.bmp")
	imgNN3D = LoadImage("images\nn3d-nm.bmp")
End If
MaskImage imgPresents, 255, 0, 255
MaskImage imgNN3D, 255, 0, 255

; LOGO FADE IN
For value# = 0 To 1 Step 0.02
	WaitTimer(frmRateTimer)

	key = GetKey()
	If key <> 0 Then
		skip = True
	End If
	If skip Then
		value = 1
	End If
	EntityAlpha objLogo, value

	If Not skip
		UpdateWorld
		RenderWorld
		Flip
	End If
Next
EntityAlpha objNuke, 0.9

; PAUSE
timr = MilliSecs()
While Not skip Or timr < MilliSecs() - 1750
	key = GetKey()
	If key <> 0 Then
		skip = True
	End If
Wend

; NUKE FADE IN, LOGO FADE OUT
For value# = 1 To 0 Step -0.1
	WaitTimer(frmRateTimer)

	key = GetKey()
	If key <> 0 Then
		skip = True
	End If
	If skip Then
		value = 0
	End If
	value = value + 0.07
	EntityAlpha objLogo, value

	If Not skip
		UpdateWorld
		RenderWorld
		Flip
	End If
Next

EntityAlpha objLogo, 0

; PAUSE
timr = MilliSecs()
While Not skip Or timr < MilliSecs() - 200
	key = GetKey()
	If key <> 0 Then
		skip = True
	End If
Wend

; NUKE TURNS AND MOVE AWAY + SCREEN RED
For count# = 0 To 180 Step 2
	WaitTimer(frmRateTimer)

	key = GetKey()
	If key <> 0 Then
		skip = True
	End If
	If skip Then
		count = 180
	End If

	MoveEntity camLogo, 0, 0, -0.021
	RotateEntity objNuke, EntityPitch(objNuke), EntityYaw(objNuke) + 2, EntityRoll(objNuke)
	fader = fader + 1.5
	CameraClsColor camLogo, fader, 0, 0

	If Not skip
		UpdateWorld
		RenderWorld
		Flip
	End If

Next

; PAUSE
timr = MilliSecs()
While Not skip Or timr < MilliSecs() - 300
	key = GetKey()
	If key <> 0 Then
		skip = True
	End If
Wend

; PRESENTS...
y = -60
While Not skip Or y > 30
	WaitTimer(frmRateTimer)
	
	UpdateWorld
	RenderWorld
	
	DrawImage imgPresents, 50, y
	
	Flip

	y = y + 1
	key = GetKey()
	If key <> 0 Then
		skip = True
	End If
Wend

; PAUSE
timr = MilliSecs()
While Not skip Or timr < MilliSecs() - 250
	key = GetKey()
	If key <> 0 Then
		skip = True
	End If
Wend

; NUCLEAR NIBBLE 3D
y = 480
While Not skip Or y < 100
	WaitTimer(frmRateTimer)
	
	UpdateWorld
	RenderWorld
	
	DrawImage imgPresents, 50, 31
	DrawImage imgNN3D, 10, y
	
	Flip
	
	y = y - 5
	key = GetKey()
	If key <> 0 Then
		skip = True
	End If
Wend

; PAUSE
timr = MilliSecs()
While Not skip Or timr < MilliSecs() - 3000
	key = GetKey()
	If key <> 0 Then
		skip = True
	End If
Wend

; UNLOAD INTRO PART 1
FreeTexture texLogo
FreeEntity camLogo
FreeEntity objLogo
FreeEntity objNuke
FreeImage imgPresents
FreeImage imgNN3D

; START INTRO PART 2
skip = False
Cls

texEarth = LoadTexture("images\earth.jpg")
objEarth = CreateSphere(32)
EntityTexture objEarth, texEarth
texMoon = LoadTexture("images\moon.jpg")
objMoon = CreateSphere(32)
EntityTexture objMoon, texMoon
sprStars = LoadSprite("images\starfield.jpg")
SpriteViewMode sprStars, 1
camIntro = CreateCamera()
ScaleEntity objEarth, 1.3, 1.3, 1.3
ScaleEntity objMoon, 0.35, 0.35, 0.35
MoveEntity objMoon, -4, 0.6, 0
MoveEntity camIntro, 0.6, 0.8, -5
ScaleSprite sprStars, 12, 12
MoveEntity sprStars, -3, 0, 3
PointEntity camIntro, objEarth
TurnEntity objEarth, 0, -80, 0
fntIntro = LoadFont("Garamond", 22, True)
SetFont fntIntro
tmr = MilliSecs()
oldMessage$ = ""
newMessage$ = ""
omA# = 0
nmA# = 0
nextMsg = 3000
finished = True
light# = 0
lgtSun = CreateLight(2)
LightRange lgtSun, 3
LightColor lgtSun, 205, 175, 0
PositionEntity lgtSun, -3, 0, -2
objExplode = CreateSphere(8)
texExplode = LoadTexture("images\explode.jpg")
EntityTexture objExplode, texExplode
PositionEntity objExplode, 0.8, 0.7, -0.3
scaleChange# = 0.03
scale# = 0
ScaleEntity objExplode, 0, 0, 0
sprBlack = CreateSprite()
SpriteViewMode sprBlack, 1
MoveEntity sprBlack, 0, 0, -4.1
ScaleSprite sprBlack, 3, 3
EntityColor sprBlack, 0, 0, 0
EntityAlpha sprBlack, light
AmbientLight 205, 205, 205
EntityAlpha objExplode, 0.7

Dim objNibble(20)
texNibble = LoadTexture("images\nibble.bmp")
ScaleTexture texNibble, 0.2, 0.2

If musicEnabled Then
	sndMusic = LoadSound("sounds\intro.mp3")
	LoopSound sndMusic
	chnMusic = PlaySound(sndMusic)
	ChannelVolume chnMusic, musicVol
End If

If soundEnabled Then
	sndWarp = LoadSound("sounds\warp.mp3")
	sndExplode = LoadSound("sounds\explode.mp3")
	SoundVolume sndExplode, soundVol
	SoundVolume sndWarp, soundVol
End If

While loops < 1700 And (Not skip)

	WaitTimer(frmRateTimer)

	loops = loops + 1
	key = GetKey()
	If key <> 0 Then
		skip = True
	End If

	If phase = 0 And (tmr < (MilliSecs() - 300)) And (Not firstDone)
		If soundEnabled And (Not sndPlay) Then
			sndPlay = True
			PlaySound sndExplode
		End If
		If scaleChange > 0 Then
			scale = scale + scaleChange
			ScaleEntity objExplode, scale, scale, scale
			If scale > 0.4 Then
				scaleChange = -0.03
			End If
		ElseIf scaleChange < 0 Then
			scale = scale + scaleChange
			ScaleEntity objExplode, scale, scale, scale
			If scale < 0.2 Then
				scaleChange = 0
			End If
		Else
			scaleChange = 0.02
			firstDone = True
			sndPlay = False
			PositionEntity objExplode, -1, 0.2, 0
		End If
	End If
	If phase = 0 And (tmr < (MilliSecs() - 1900)) And firstDone
		If soundEnabled And (Not sndPlay) Then
			sndPlay = True
			PlaySound sndExplode
		End If
		If scaleChange > 0 Then
			scale = scale + scaleChange
			ScaleEntity objExplode, scale, scale, scale
			If scale > 0.45 Then
				scaleChange = -0.02
			End If
		ElseIf scaleChange < 0 Then
			scale = scale + scaleChange
			ScaleEntity objExplode, scale, scale, scale
			If scale < 0.2 Then
				scaleChange = 0
			End If
		End If
	End If

	TurnEntity objEarth, 0, 0.1, 0
	PointEntity objMoon, objEarth
	MoveEntity objMoon, -0.01, 0, 0

	If (tmr < MilliSecs() - nextMsg) And finished
		finished = False
		phase = phase + 1
		msgid = msgid + 1
		Select phase
			Case 1
				newMessage = "This is the year 2053 here on Earth,"
			Case 2
				newMessage = "Another nuclear war has just ended,"
			Case 3
				newMessage = "But wastes are still plaguing the world."
			Case 4
				newMessage = "But now, there is a new hope..."
			Case 5
				newMessage = "An unknown alien lifeform is coming to save humanity,"
			Case 6
				newMessage = "Or what is remaining."
			Case 7
				newMessage = "Little is known about it, except that this worm-like creature"
			Case 8
				newMessage = "Can absorb radioactivity and clean the Earth."
		End Select
		nextMsg = (Len(newMessage) - 4) * 100
	End If
	
	If phase > 8 Then
		light = light + 0.01
		EntityAlpha sprBlack, light
		ChannelVolume chnMusic, musicVol * (1 - light)
	End If

	If (Not coming) And (phase = 5) Then
		If soundEnabled Then PlaySound sndWarp
		coming = True
		SeedRnd MilliSecs()
		For count = 0 To 19
			objNibble(count) = CreateSphere(2)
			PositionEntity objNibble(count), EntityX(camIntro), EntityY(camIntro) + 1, EntityZ(camIntro)
			ScaleEntity objNibble(count), 0.03, 0.03, 0.03
			EntityTexture objNibble(count), texNibble
			RotateEntity objNibble(count), Rand(0, 360), Rand(0, 360), Rand(0, 360)
		Next
		PointEntity objNibble(0), objEarth
		TurnEntity objNibble(0), -8, 0, 0
	End If
	If coming Then
		For count = 19 To 1 Step -1
			PositionEntity objNibble(count), EntityX(objNibble(count - 1)), EntityY(objNibble(count - 1)), EntityZ(objNibble(count - 1))
		Next
		MoveEntity objNibble(0), 0, 0, 0.05
	End If
	
	UpdateWorld
	RenderWorld
	
	If msgid <> lmsgid Then
		If omA > 0 Then
			omA = omA - 0.05
		ElseIf nmA < 1 Then
			nmA = nmA + 0.05
		Else
			oldMessage = newMessage
			newMessage = ""
			omA = 1
			nmA = 0
			lmsgid = msgid	
			finished = True
			tmr = MilliSecs()
		End If	
	End If
	
	If omA > 0 Then
		Color 105* omA, 105 * omA, 105 * omA
		Text 321, 421, oldMessage, True, True
		Color 25 * omA, 168 * omA, 230 * omA
		Text 320, 420, oldMessage, True, True
	End If
	
	If nmA > 0 Then
		Color 105 * nmA, 105 * nmA, 105 * nmA
		Text 321, 421, newMessage, True, True
		Color 25 * nmA, 168 * nmA, 230 * nmA
		Text 320, 420, newMessage, True, True
	End If
	
	Flip
Wend

; UNLOAD INTRO PART 2
FreeTexture texEarth
FreeEntity objEarth
FreeTexture texMoon
FreeEntity objMoon
FreeEntity sprStars
FreeEntity camIntro
FreeFont fntIntro
FreeTexture texNibble
If coming Then
	For count = 0 To 19
		FreeEntity objNibble(count)
	Next
End If
FreeEntity lgtSun
FreeEntity objExplode
FreeTexture texExplode
If musicEnabled Then FreeSound sndMusic
If soundEnabled Then FreeSound sndExplode
If soundEnabled Then FreeSound sndWarp
FreeEntity sprBlack

Cls
