; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

; WHEN YOU DIE, LEVEL RESTART
.Kill

; NEW LEVEL
.Level

; FREE WALLS, IF ANY
If newg Then
	For x = 1 To 25
		For y = 1 To 25
			If walls(x, y) Then
				FreeEntity objWalls(x, y)
			End If
		Next		
	Next
End If
If objFloor <> 0 Then
	FreeEntity objFloor
	FreeEntity NorthWall
	FreeEntity SouthWall
	FreeEntity EastWall
	FreeEntity WestWall
	FreeEntity Sky
	FreeTexture texFloor
	FreeTexture texWall
	FreeTexture texBigWall
	objFloor = 0
End If

; SET TILESET AND LEVEL NAME
Select level
	Case 1
		TileSet = 1
		LevelName$ = "Easy Go"
	Case 2
		TileSet = 1
		LevelName$ = "Piped I"
	Case 3
		TileSet = 1
		LevelName$ = "Backslash"
	Case 4
		TileSet = 1
		LevelName$ = "Piped ]["
	Case 5
		TileSet = 1
		LevelName$ = "Squared"
	Case 6
		TileSet = 1
		LevelName$ = "Smooth Ride"
	Case 7
		TileSet = 1
		LevelName$ = "Timely"
	Case 8
		TileSet = 1
		LevelName$ = "Zed"
	Case 9
		TileSet = 1
		LevelName$ = "Cornered"
	Case 10
		TileSet = 1
		LevelName$ = "Polka Dot"
	Case 11
		TileSet = 1
		LevelName$ = "larsg's X"
	Case 12
		TileSet = 1
		LevelName$ = "Epilepsilon"
	Case 13
		TileSet = 1
		LevelName$ = "Double Squared"
	Case 14
		TileSet = 1
		LevelName$ = "Diamonds"
	Case 15
		TileSet = 1
		LevelName$ = "Symmetric"
	Case 16
		TileSet = 1
		LevelName$ = "90 Degrees"
	Case 17
		TileSet = 1
		LevelName$ = "Parallels"
	Case 18
		TileSet = 1
		LevelName$ = "The Silo"
	Case 19
		TileSet = 1
		LevelName$ = "Randomness"
	Case 20
		TileSet = 1
		LevelName$ = "The Dungeon"
End Select

; LOAD TILES
texFloor = LoadTexture("tilesets\floor" + TileSet + ".jpg")
texWall = LoadTexture("tilesets\wall" + TileSet + ".jpg")
texBigWall = LoadTexture("tilesets\bigwall" + TileSet + ".jpg")

ScaleTexture texBigWall, 0.08, 0.3

; LOAD WALLS, FLOOR, ETC.

objFloor = CreateCube()
EntityTexture objFloor, texFloor
ScaleEntity objFloor, 25, 0.001, 25
ScaleTexture texFloor, 0.1, 0.1
If transparency Then
	EntityAlpha objFloor, 0.8
End If

If mirror Then
	mirFloor = CreateMirror()
	PositionEntity mirFloor, 0, -0.1, 0
End If

SeedRnd(MilliSecs())
Sky = CreateCube()
ScaleEntity Sky, 50, 50, 50
MoveEntity Sky, 0, 45, 0
FlipMesh Sky
texSky = LoadTexture("tilesets\sky" + TileSet + ".jpg")
EntityTexture Sky, texSky
EntityAlpha Sky, 0.85

NorthWall = CreateCube()
EntityTexture NorthWall, texBigWall
EntityType NorthWall, 2
ScaleEntity NorthWall, 26, 3, 1
PositionEntity NorthWall, 0, 1, 25.5
SouthWall = CreateCube()
EntityTexture SouthWall, texBigWall
EntityType SouthWall, 2
ScaleEntity SouthWall, 26, 3, 1
PositionEntity SouthWall, 0, 1, -25.5
EastWall = CreateCube()
EntityTexture EastWall, texBigWall
EntityType EastWall, 2
ScaleEntity EastWall, 1, 3, 26
PositionEntity EastWall, 25.5, 1, 0
WestWall = CreateCube()
EntityTexture WestWall, texBigWall
EntityType WestWall, 2
ScaleEntity WestWall, 1, 3, 26
PositionEntity WestWall, -25.5, 1, 0

If box Then
	FreeEntity lgtBox
	FreeEntity objBox
	box = False
End If

If present Then
	FreeEntity lgtNuke
	FreeEntity objNuke
	present = False
End If

; LOAD LEVEL FILES
filLevel = ReadFile("data\level" + level + ".dat")
For x = 1 To 25
	temp$ = ReadLine(filLevel)
	For y = 1 To 25
		walls(x, y) = Mid(temp$, y, 1)
	Next
Next
CloseFile(filLevel)

; CREATE AND PLACE WALLS
wallcount = 0
SeedRnd MilliSecs()
For x = 1 To 25
	For y = 1 To 25
		If walls(x, y) > 0 Then
			If walls(x, y) = 1 Then
				objWalls(x, y) = CreateCube()
				RotateEntity objWalls(x, y), Rand(0, 1) * 180, Rand(0, 3) * 90, 0
			Else
				objWalls(x, y) = LoadMesh("models\corner.3ds")
				Select walls(x, y)
					Case 2
						TurnEntity objWalls(x, y), 0, 90, 0
					Case 3
						TurnEntity objWalls(x, y), 0, 0, 0
					Case 4
						TurnEntity objWalls(x, y), 0, 270, 0
					Case 5
						TurnEntity objWalls(x, y), 0, 180, 0
				End Select
			End If
			EntityTexture objWalls(x, y), texWall
			EntityType objWalls(x, y), typWalls
			ScaleEntity objWalls(x, y), 1, 1.5, 1
			PositionEntity objWalls(x, y), x * 2 - 26 , 0.01, y * 2 - 26
			wallcount = wallcount + 1
		End If
	Next
Next

If newg Then

	FreeEntity camDefault
	FreeEntity lgtHead
	For count = 0 To length
		FreeEntity objNibbler(count)
	Next		

End If

newg = True

; LOAD A NEW MUSIC
If musicEnabled Then
	mVol# = 0.0
	SeedRnd MilliSecs()
	FreeSound sndMusic
	sndMusic = LoadSound("sounds\music" + Rand(1, 3) + ".mp3")
	LoopSound sndMusic
	chnMusic = PlaySound(sndMusic)
	ChannelVolume chnMusic, mVol
End If

.Init

; GAME INITIALIZATION, SET NIBBLER TO 50, LOAD IT
length = 50
If sphereDetail > 1 Then
	objNibbler(0) = CreateSphere(sphereDetail)
ElseIf sphereDetail = 1 Then
	objNibbler(0) = CreateCone(3)
ElseIf sphereDetail = 0 Then
	objNibbler(0) = LoadSprite("images\nibbler.bmp", 4)
	SpriteViewMode objNibbler(0), 1
End If

camNibbler = CreateCamera(objNibbler(0))
MoveEntity camNibbler, 0, 5, 0
PointEntity camNibbler, objNibbler(0)
MoveEntity camNibbler, 5, 0, 0
CameraViewport camNibbler, 450, 370, 149, 39
If complexlevel Then
	CameraClsColor camNibbler, 77, 155, 0
Else
	MoveEntity camNibbler, 0, -1000, 0
End If

If sphereDetail > 0 Then
	EntityTexture objNibbler(0), texNibble
End If
EntityType objNibbler(0), typHead
EntityRadius objNibbler(0), 0.9
RotateEntity objNibbler(0), 0, 0, 0

camDefault = CreateCamera()
CameraViewport camDefault, 25, 25, 589, 329
CameraRange camDefault, 1.15, 1000
objCamTarget = CreatePivot(objNibbler(0))

SeedRnd MilliSecs()
For count = 1 To length
	If sphereDetail > 1 Then
		objNibbler(count) = CreateSphere(sphereDetail)
	ElseIf sphereDetail = 1 Then
		objNibbler(count) = CreateCone(3)
	ElseIf sphereDetail = 0 Then
		objNibbler(count) = LoadSprite("images\nibbler.bmp", 4)
		SpriteViewMode objNibbler(count), 1
	End If
	
	If sphereDetail > 0 Then
		EntityTexture objNibbler(count), texNibble
	End If
	RotateEntity objNibbler(count), Rnd(0, 360), Rnd(0, 360), Rnd(0, 360)
	EntityType objNibbler(count), typNibble
	EntityRadius objNibbler(count), 1
	PositionEntity objNibbler(count), 0, count / 2, 0
Next

timer = MilliSecs()

MoveEntity camDefault, -10, 4.5, 0
MoveEntity objCamTarget, -10, 4.5, 0
PointEntity camDefault, objNibbler(0)
lgtHead = CreateLight(2, objNibbler(0))
LightColor lgtHead, 205, 255, 0
LightRange lgtHead, 2

FPSView = False
PositionEntity objCamTarget, -10, 4.5, 0, False

; ENTERING LEVEL ...
Gosub RenderScreen

DrawImage imgWindow, 125, 100

ShowPointer

Color 0, 0, 0
Text 146, 106, "Entering Level " + level + ": " + LevelName$ + "..."
Color 0, 105, 0
Text 145, 105, "Entering Level " + level + ": " + LevelName$ + "..."

SeedRnd MilliSecs()
tip = Rand(1, 5)
Color 0, 0, 0
Select tip
	Case 1
		Text 286, 171, "You can close this window by pressing", True
		Text 286, 191, "escape (ESC), enter or space bar.", True
		Color 0, 255, 0
		Text 285, 170, "You can close this window by pressing", True
		Text 285, 190, "escape (ESC), enter or space bar.", True
	Case 2
		Text 286, 151, "When this window pops up, check", True
		Text 286, 171, "carefully the surroundings, so that you", True
		Text 286, 191, "can decide what action to take first", True
		Text 286, 211, "(turning left/right, etc).", True
		Color 0, 255, 0
		Text 285, 150, "When this window pops up, check", True
		Text 285, 170, "carefully the surroundings, so that you", True
		Text 285, 190, "can decide what action to take first", True
		Text 285, 210, "(turning left/right, etc).", True
	Case 3
		If level < 20
			Text 286, 171, "Remember that level " + (level + 1) + " will be", True
			Text 286, 191, "even harder.", True
			Color 0, 255, 0
			Text 285, 170, "Remember that level " + (level + 1) + " will be", True		
			Text 285, 190, "even harder.", True
		Else
			Text 286, 171, "Almost there! One level to go, are you", True
			Text 286, 191, "sure you can Handle it?", True
			Color 0, 255, 0
			Text 285, 170, "Almost there! One level to go, are you", True
			Text 285, 190, "sure you can Handle it?", True
		End If
	Case 4
		Text 286, 171, "Random powerups pop every 12", True
		Text 286, 191, "seconds, pick them wisely.", True
		Color 0, 255, 0
		Text 285, 170, "Random powerups pop every 12", True
		Text 285, 190, "seconds, pick them wisely.", True
	Case 5
		Text 286, 171, "Making the widest turn use more of", True
		Text 286, 191, "your Nibble; plan your curves.", True
		Color 0, 255, 0
		Text 285, 170, "Making the widest turn use more of", True
		Text 285, 190, "your Nibble; plan your curves.", True
End Select

Gosub CloseWindow

HidePointer